plugin simpleMeshMod Vu_MarchingAnts
	name:"Vu_MarchingAnts"
	classID:#(0x75D71596, 0x20FF6E9E)
	category:"MCG Clone Tools"
(
	local pluginDefinitionFile -- the plugin definition file
	local pluginInstance -- the plugin instance created from the plugin definition
	local _meshWrapper -- the dotnet wrapper around the stack mesh pointer
	local argsType = dotNetClass "System.Object[]" -- used when creating args array
	local dotnet_ValueToDotNetObject = dotnet.ValueToDotNetObject
	local tmHandler

	-- function wrappers
	local _meshWrapper_SetValue
	local pluginInstance_UpdateMesh

	-- value wrapper local and function wrapper declarations
	local Pick_Curve_Wrapper, Pick_Curve_Wrapper_SetValue
	local meshWrapper, meshWrapper_SetValue
	local modifierTransformWrapper, modifierTransformWrapper_SetValue


	parameters main rollout:params
	(
		March_____ ui:March_____ default:0 type:#integer animatable:true
		From_ ui:From_ default:1 type:#integer animatable:true
		Step_ ui:Step_ default:1 type:#integer animatable:true
		Count_ ui:Count_ default:11 type:#integer animatable:true
		To_ ui:To_ default:999 type:#integer animatable:true
		Closed_Loop_ ui:Closed_Loop_ default:False type:#boolean animatable:true
		Pick_Curve_ ui:Pick_Curve_ type:#node useNodeOsValidity:true useNodeTmValidity:true
		Start_angle_ ui:Start_angle_ default:0 type:#float animatable:true
		End_angle_ ui:End_angle_ default:0 type:#float animatable:true
		Align_Axis_ ui:Align_Axis_ default:0 type:#integer animatable:true
		Flip ui:Flip default:False type:#boolean animatable:true
		Adjust_Y_Rot_ ui:Adjust_Y_Rot_ default:0 type:#float animatable:true
		Adjust_X_Rot_ ui:Adjust_X_Rot_ default:0 type:#float animatable:true
		Adjust_Z_Rot_ ui:Adjust_Z_Rot_ default:0 type:#float animatable:true
		CosmicVibes ui:CosmicVibes default:0 type:#float animatable:true
		TimeWarp ui:TimeWarp default:1 type:#float animatable:true
		VibraFunc ui:VibraFunc default:0 type:#integer animatable:true
		Amplify ui:Amplify default:1 type:#float animatable:true
		SineWaveAxis_ ui:SineWaveAxis_ default:2 type:#integer animatable:true
		Abs ui:Abs default:False type:#boolean animatable:true
		FlipAbs ui:FlipAbs default:False type:#boolean animatable:true
		Freq ui:Freq default:0 type:#float animatable:true
		Phase ui:Phase default:0 type:#float animatable:true
		Amplitude ui:Amplitude default:0 type:#float animatable:true
		_dummy type:#boolean -- this exists to enable easy invalidation of the object        
		pluginGraph type:#filename assettype:#MaxCreationGraph readOnly:true enumAsAsset:true 
        pluginGraphDependencies type:#filenametab assettype:#MaxCreationGraph readOnly:true enumAsAsset:true tabSize:0 tabSizeVariable:true
    ) 

rollout params "Ants Parameters"
	(
		pickbutton Pick_Curve_ "Pick Curve:" autodisplay:true type:#node
		slider Align_Axis_ "Align Axis:" range:[0, 2, 0] type:#integer align:#left
		label lab11 "X                  Y                  Z" align:#left
		checkbox Flip "Flip" checked:False  align:#right

		spinner Adjust_X_Rot_ "Adjust X Rot:" range:[-9999, 9999, 0] type:#float
		spinner Adjust_Y_Rot_ "Adjust Y Rot:" range:[-9999, 9999, 0] type:#float
		spinner Adjust_Z_Rot_ "Adjust Z Rot:" range:[-9999, 9999, 0] type:#float

		spinner From_ "From:" range:[1, 9999, 1] type:#integer
		spinner Step_ "Step:" range:[1, 999, 1] type:#integer
		label lab21 "(higher ->  smoother)"  align:#right
		checkbox Closed_Loop_ "Closed Loop?" checked:False  align:#right
		
		spinner Count_ "Count:" range:[1, 9999, 11] type:#integer
		label lab31 "(1. If closed, use odd count)" align:#left
		label lab32 "(2. Should be a mult. of Step)" align:#left
		spinner To_ "To:" range:[1, 9999, 999] type:#integer

		spinner March_____ "March !!!:" range:[0, 9999, 0] type:#integer

		spinner Start_angle_ "Start angle:" range:[-9999, 9999, 0] type:#float
		spinner End_angle_ "End angle:" range:[-9999, 9999, 0] type:#float

		Group "Sine Wave Displace"
		(
			spinner Freq "Freq" range:[-9999, 9999, 0] type:#float
			spinner Phase "Phase" range:[-9999, 9999, 0] type:#float
			spinner Amplitude "Amplitude" range:[-9999, 9999, 0] type:#float
			slider SineWaveAxis_ "Displace Axis:" range:[0, 2, 2] type:#integer align:#left
			label lab51 "X                  Y                  Z" align:#left
			checkbox Abs "Abs" checked:False  align:#right
			checkbox FlipAbs "FlipAbs" checked:False  align:#right
		)

		Group "Vibrate"
		(
			slider VibraFunc "VibraFunc" range:[0, 3, 0] type:#integer
			label lab41 "Sine : Wrap : Log10 :  LogN"
			label lab42 ""
			spinner CosmicVibes "CosmicVibes" range:[-9999, 9999, 0] type:#float
			spinner TimeWarp "TimeWarp" range:[0, 999, 1] type:#float
			spinner Amplify "Amplify" range:[-999, 999, 1] type:#float
		)

	)
rollout inforoll "About"
	(
		Group "Vu Marching Ants Info"
		(
			label lab91 "Author: Vu Nguyen" align:#left
			label lab92 "(c) Vu Nguyen 2015" align:#left
			label lab94 "Version: 2.00.00" align:#left
			label lab95 "Email: vusta@hotmail.com" align:#left
		)

	)

	fn initialize = 
	(
		pluginDefinitionFile = @"C:/Users/Honey/Autodesk/3ds Max 2016/Max Creation Graph/Tools/Vu_MarchingAnts.maxtool"
		local c = dotNetClass "Viper3dsMaxBridge.ModifierPluginInstance"
		local cid = this.classId
		local refMakerWrapperClass = dotnetclass "Autodesk.Max.MaxPlus.ReferenceMaker"
		refMakerWrapper = refMakerWrapperClass._CreateWrapper this
		pluginInstance = c.CreateInstance cid[1] cid[2] pluginDefinitionFile refMakerWrapper
		pluginInstance_UpdateMesh = pluginInstance.UpdateMesh
		local meshWrapperClass = dotnetclass "Autodesk.Max.MaxPlus.Mesh"
		_meshWrapper = meshWrapperClass._CreateWrapper undefined
		_meshWrapper_SetValue = _meshWrapper._SetValue
		pluginGraph = pluginDefinitionFile
		pluginGraphDependencies = #(@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\MinusOne.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\Lesser.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\ArrayFromToStep.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\PlusOne.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\TransformsOnCurve.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\TransformOnCurve.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\LerpTangentOnCurve.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\SampleLerp.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\ChooseAxis.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\Array3.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\RotateMesh.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\DeformMeshPoints.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\Array4.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\TransformMesh.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\NodePositionInLocalSpace.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\NodeTMInLocalSpace.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\OffsetMesh.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\DropLast.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\LastIndex.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\MinusOne.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\SelectByIndex.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\SkipOne.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\ArrayRecycleFirstToLast.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\First.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\Remap.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\SineWave.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\OffsetMeshesByVectors.maxcompound")

		-- value wrapper local initializations
		local Pick_Curve_WrapperClass = dotNetClass "Autodesk.Max.MaxPlus.INode"
		Pick_Curve_Wrapper = Pick_Curve_WrapperClass._CreateWrapper (undefined)
		Pick_Curve_Wrapper_SetValue = Pick_Curve_Wrapper._SetValue
		local meshWrapperClass = dotNetClass "Autodesk.Max.MaxPlus.Mesh"
		meshWrapper = meshWrapperClass._CreateWrapper (undefined)
		meshWrapper_SetValue = meshWrapper._SetValue
		local modifierTransformWrapperClass = dotNetClass "Autodesk.Max.MaxPlus.Matrix3"
		modifierTransformWrapper = modifierTransformWrapperClass._CreateWrapper (matrix3 1)
		modifierTransformWrapper_SetValue = modifierTransformWrapper._SetValue

	)

	fn updateMesh = 
	(
		if (tmHandler == undefined) then ( tmHandler = when transform owningNode changes do _dummy = not _dummy )
		if (pluginInstance == undefined) then ( return undefined )
		local args = dotnet_ValueToDotNetObject #(March_____, From_, Step_, Count_, To_, Closed_Loop_, Pick_Curve_Wrapper, Start_angle_, End_angle_, meshWrapper, Align_Axis_, Flip, Adjust_Y_Rot_, Adjust_X_Rot_, Adjust_Z_Rot_, CosmicVibes, TimeWarp, VibraFunc, Amplify, modifierTransformWrapper, SineWaveAxis_, Abs, FlipAbs, Freq, Phase, Amplitude) argsType
		pluginInstance_UpdateMesh (currentTime as integer) _meshWrapper args
	)
	
	on modifyMesh do
	(
		try 
		(
			_meshWrapper_SetValue mesh
			Pick_Curve_Wrapper_SetValue Pick_Curve_
			meshWrapper_SetValue mesh
			modifierTransformWrapper_SetValue owningNode.Transform

			updateMesh()
			_meshWrapper_SetValue undefined

		)
		catch()
		ok
	)

	on create do 
	(
		initialize()
	)

	on clone fromObj do 
	(
		initialize()
	)

	on load do 
	(
		initialize()
	)

	on update do 
	(
		initialize()
	)
)
